import Ember from 'ember';
import Component from '@ember/component';
import layout from '../templates/components/form-duration';
import { seconds_to_str, str_to_seconds } from '../utils/duration';

export default Component.extend({
  layout,

  displayValue: Ember.computed('value', {
    get() {
      const rv = seconds_to_str(this.get('value'), this.get('extra.withSeconds'));
      return rv;
    },
    set(key, value) {
      this.set('value', str_to_seconds(value, this.get('extra.withSeconds')));
      return seconds_to_str(this.get('value'), this.get('extra.withSeconds'));
    }
  }),

  validate(widget) {
    return widget.validate();
  },
});
